commit a9e9ff7b8a4d10ccf54dd4a641dd55c1b1645e17
Author: Jakub Jelinek <jakub@redhat.com>
Date:   Thu Feb 27 10:45:30 2020 +0100

    gimplify: Don't optimize register const vars to static [PR93949]
    
    The following testcase is rejected, while it was accepted in 3.4 and earlier
    (before tree-ssa merge).
    The problem is that we decide to promote the const variable to TREE_STATIC,
    but TREE_STATIC DECL_REGISTER VAR_DECLs may only be the global register vars
    and so assemble_variable/make_decl_rtl diagnoses it.
    
    Either we do what the following patch does, where we could consider
    register as a hint the user doesn't want such optimization, because if
    something is forced static, it is not "register" anymore and register static
    is not valid in C either, or we could clear DECL_REGISTER instead, but would
    still need to punt at least on DECL_HARD_REGISTER cases.
    
    2020-02-27  Jakub Jelinek  <jakub@redhat.com>
    
            PR c/93949
            * gimplify.c (gimplify_init_constructor): Don't promote readonly
            DECL_REGISTER variables to TREE_STATIC.
    
            * gcc.c-torture/compile/pr93949.c: New test.

diff --git a/gcc/ChangeLog b/gcc/ChangeLog
index 6771ccc9019..22dcc34efec 100644
--- a/gcc/ChangeLog
+++ b/gcc/ChangeLog
@@ -1,3 +1,9 @@
+2020-02-27  Jakub Jelinek  <jakub@redhat.com>
+
+	PR c/93949
+	* gimplify.c (gimplify_init_constructor): Don't promote readonly
+	DECL_REGISTER variables to TREE_STATIC.
+
 2020-03-04  Jakub Jelinek  <jakub@redhat.com>
 
 	* BASE-VER: Set to 8.4.1.
diff --git a/gcc/gimplify.c b/gcc/gimplify.c
index cb5bdee2aac..a685dc87d7d 100644
--- a/gcc/gimplify.c
+++ b/gcc/gimplify.c
@@ -4814,6 +4814,7 @@ gimplify_init_constructor (tree *expr_p, gimple_seq *pre_p, gimple_seq *post_p,
 	    && num_nonzero_elements > 1
 	    && TREE_READONLY (object)
 	    && VAR_P (object)
+	    && !DECL_REGISTER (object)
 	    && (flag_merge_constants >= 2 || !TREE_ADDRESSABLE (object))
 	    /* For ctors that have many repeated nonzero elements
 	       represented through RANGE_EXPRs, prefer initializing
diff --git a/gcc/testsuite/ChangeLog b/gcc/testsuite/ChangeLog
index 8a4be391de8..b0c4d406fdf 100644
--- a/gcc/testsuite/ChangeLog
+++ b/gcc/testsuite/ChangeLog
@@ -1,3 +1,8 @@
+2020-02-27  Jakub Jelinek  <jakub@redhat.com>
+
+	PR c/93949
+	* gcc.c-torture/compile/pr93949.c: New test.
+
 2020-02-04  Tobias Burnus  <tobias@codesourcery.com>
 
 	Backported from mainline
diff --git a/gcc/testsuite/gcc.c-torture/compile/pr93949.c b/gcc/testsuite/gcc.c-torture/compile/pr93949.c
new file mode 100644
index 00000000000..bbda0209802
--- /dev/null
+++ b/gcc/testsuite/gcc.c-torture/compile/pr93949.c
@@ -0,0 +1,7 @@
+/* PR c/93949 */
+
+void
+foo (void)
+{
+  register const double d[3] = { 0., 1., 2. };
+}

